import time
import random
from machine import Pin, I2C
from imu import MPU6050
from ssd1306 import SSD1306_I2C

WIDTH = 128
HEIGHT = 32

i2c_oled = I2C(0, sda=Pin(4), scl=Pin(5), freq=200000)
time.sleep_ms(100)
oled = SSD1306_I2C(WIDTH, HEIGHT, i2c_oled)

i2c_imu = I2C(1, sda=Pin(14), scl=Pin(15), freq=400000)
time.sleep_ms(100)
imu = MPU6050(i2c_imu)

button_pin = Pin(18, Pin.IN, Pin.PULL_UP)
direction_pin = Pin(17, Pin.IN, Pin.PULL_UP)
step_pin  = Pin(16, Pin.IN, Pin.PULL_UP)

previous_value = True
button_down = False

section = 0
mult = 1
dice = 2
add = 0
i = j = h = result = random_number = 0

while True:
    
    ax=round(imu.accel.x,2)
    ay=round(imu.accel.y,2)
    az=round(imu.accel.z,2)
    print("ax",ax,"\t","ay",ay,"\t","az",az,"\t",end="\r")
    
    oled.text(str(mult) + "d" + str(dice) + "+" + str(add), 40, 20)
    oled.show()
    
    if section == 0:
        oled.line(43,28,41,30,1)
        oled.line(43,28,45,30,1)
        if previous_value != step_pin.value():
            if step_pin.value() == False:
                if direction_pin.value() == False:
                    mult = mult - 1
                    #time.sleep(0.1)
                    oled.fill(0)
                else:
                    mult = mult + 1
                    #time.sleep(0.1)
                    oled.fill(0)
            previous_value = step_pin.value()
            
    elif section == 1:
        oled.line(58,28,56,30,1)
        oled.line(58,28,60,30,1)
        if previous_value != step_pin.value():
            if step_pin.value() == False:
                if direction_pin.value() == False:
                    dice = dice - 1
                    #time.sleep(0.1)
                    oled.fill(0)
                else:
                    dice = dice + 1
                    #time.sleep(0.1)
                    oled.fill(0)
            previous_value = step_pin.value()
         
    elif section == 2:
        oled.line(75,28,73,30,1)
        oled.line(75,28,77,30,1)
        if previous_value != step_pin.value():
            if step_pin.value() == False:
                if direction_pin.value() == False:
                    add = add - 1
                    #time.sleep(0.1)
                    oled.fill(0)
                else:
                    add = add + 1
                    #time.sleep(0.1)
                    oled.fill(0)
            previous_value = step_pin.value()
         
    elif section == 3:
        section = 0
        
    if button_pin.value() == False:
         section = section + 1
         oled.fill(0)
         time.sleep(0.5)
    
    #if previous_value != step_pin.value():
    #     if step_pin.value() == False:
    #         if direction_pin.value() == False:
    #             print("turned left")
    #         else:
    #             print("turned right")
    #     previous_value = step_pin.value() 
    #if button_pin.value() == False:
    #     print("button pressed")
    
    if ax > 1.5 or ay > 1.5 or az > 1.5:
        h = j = 0
        oled.fill(0)
        for i in range (0, mult):
            random_number = round(random.uniform(1, dice))
            oled.text(str(random_number) + ", ", h*22, j*10 + 0)
            oled.show()
            h = h + 1
            if h > 4:
                h = 0
                j = j + 1 
            result = result + random_number
            time.sleep(0.4)
        result = result + add
        oled.fill(0)
        oled.text(str(result), 50, 20)
        oled.show()
        time.sleep(2)
        result = 0
        oled.fill(0)
        